/*
 * coded by Ketmar // Invisible Vector <ketmar@ketmar.no-ip.org>
 * Understanding is not required. Only obedience.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3 of the License ONLY.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
module iv.xcolornames;

public struct XColorName {
  ubyte r, g, b;
  string name;
}

static immutable XColorName[661] xColorNameList = [
//! $Xorg: rgb.txt,v 1.3 2000/08/17 19:54:00 cpqbld Exp $
XColorName(255, 250, 250, "snow"),
XColorName(248, 248, 255, "GhostWhite"),
XColorName(245, 245, 245, "WhiteSmoke"),
XColorName(220, 220, 220, "gainsboro"),
XColorName(255, 250, 240, "FloralWhite"),
XColorName(253, 245, 230, "OldLace"),
XColorName(250, 240, 230, "linen"),
XColorName(250, 235, 215, "AntiqueWhite"),
XColorName(255, 239, 213, "PapayaWhip"),
XColorName(255, 235, 205, "BlanchedAlmond"),
XColorName(255, 228, 196, "bisque"),
XColorName(255, 218, 185, "PeachPuff"),
XColorName(255, 222, 173, "NavajoWhite"),
XColorName(255, 228, 181, "moccasin"),
XColorName(255, 248, 220, "cornsilk"),
XColorName(255, 255, 240, "ivory"),
XColorName(255, 250, 205, "LemonChiffon"),
XColorName(255, 245, 238, "seashell"),
XColorName(240, 255, 240, "honeydew"),
XColorName(245, 255, 250, "MintCream"),
XColorName(240, 255, 255, "azure"),
XColorName(240, 248, 255, "AliceBlue"),
XColorName(230, 230, 250, "lavender"),
XColorName(255, 240, 245, "LavenderBlush"),
XColorName(255, 228, 225, "MistyRose"),
XColorName(255, 255, 255, "white"),
XColorName(  0,   0,   0, "black"),
XColorName( 47,  79,  79, "DarkSlateGray"),
XColorName( 47,  79,  79, "DarkSlateGrey"),
XColorName(105, 105, 105, "DimGray"),
XColorName(105, 105, 105, "DimGrey"),
XColorName(112, 128, 144, "SlateGray"),
XColorName(112, 128, 144, "SlateGrey"),
XColorName(119, 136, 153, "LightSlateGray"),
XColorName(119, 136, 153, "LightSlateGrey"),
XColorName(190, 190, 190, "gray"),
XColorName(190, 190, 190, "grey"),
XColorName(211, 211, 211, "LightGrey"),
XColorName(211, 211, 211, "LightGray"),
XColorName( 25,  25, 112, "MidnightBlue"),
XColorName(  0,   0, 128, "navy"),
XColorName(  0,   0, 128, "NavyBlue"),
XColorName(100, 149, 237, "CornflowerBlue"),
XColorName( 72,  61, 139, "DarkSlateBlue"),
XColorName(106,  90, 205, "SlateBlue"),
XColorName(123, 104, 238, "MediumSlateBlue"),
XColorName(132, 112, 255, "LightSlateBlue"),
XColorName(  0,   0, 205, "MediumBlue"),
XColorName( 65, 105, 225, "RoyalBlue"),
XColorName(  0,   0, 255, "blue"),
XColorName( 30, 144, 255, "DodgerBlue"),
XColorName(  0, 191, 255, "DeepSkyBlue"),
XColorName(135, 206, 235, "SkyBlue"),
XColorName(135, 206, 250, "LightSkyBlue"),
XColorName( 70, 130, 180, "SteelBlue"),
XColorName(176, 196, 222, "LightSteelBlue"),
XColorName(173, 216, 230, "LightBlue"),
XColorName(176, 224, 230, "PowderBlue"),
XColorName(175, 238, 238, "PaleTurquoise"),
XColorName(  0, 206, 209, "DarkTurquoise"),
XColorName( 72, 209, 204, "MediumTurquoise"),
XColorName( 64, 224, 208, "turquoise"),
XColorName(  0, 255, 255, "cyan"),
XColorName(224, 255, 255, "LightCyan"),
XColorName( 95, 158, 160, "CadetBlue"),
XColorName(102, 205, 170, "MediumAquamarine"),
XColorName(127, 255, 212, "aquamarine"),
XColorName(  0, 100,   0, "DarkGreen"),
XColorName( 85, 107,  47, "DarkOliveGreen"),
XColorName(143, 188, 143, "DarkSeaGreen"),
XColorName( 46, 139,  87, "SeaGreen"),
XColorName( 60, 179, 113, "MediumSeaGreen"),
XColorName( 32, 178, 170, "LightSeaGreen"),
XColorName(152, 251, 152, "PaleGreen"),
XColorName(  0, 255, 127, "SpringGreen"),
XColorName(124, 252,   0, "LawnGreen"),
XColorName(  0, 255,   0, "green"),
XColorName(127, 255,   0, "chartreuse"),
XColorName(  0, 250, 154, "MediumSpringGreen"),
XColorName(173, 255,  47, "GreenYellow"),
XColorName( 50, 205,  50, "LimeGreen"),
XColorName(154, 205,  50, "YellowGreen"),
XColorName( 34, 139,  34, "ForestGreen"),
XColorName(107, 142,  35, "OliveDrab"),
XColorName(189, 183, 107, "DarkKhaki"),
XColorName(240, 230, 140, "khaki"),
XColorName(238, 232, 170, "PaleGoldenrod"),
XColorName(250, 250, 210, "LightGoldenrodYellow"),
XColorName(255, 255, 224, "LightYellow"),
XColorName(255, 255,   0, "yellow"),
XColorName(255, 215,   0, "gold"),
XColorName(238, 221, 130, "LightGoldenrod"),
XColorName(218, 165,  32, "goldenrod"),
XColorName(184, 134,  11, "DarkGoldenrod"),
XColorName(188, 143, 143, "RosyBrown"),
XColorName(205,  92,  92, "IndianRed"),
XColorName(139,  69,  19, "SaddleBrown"),
XColorName(160,  82,  45, "sienna"),
XColorName(205, 133,  63, "peru"),
XColorName(222, 184, 135, "burlywood"),
XColorName(245, 245, 220, "beige"),
XColorName(245, 222, 179, "wheat"),
XColorName(244, 164,  96, "SandyBrown"),
XColorName(210, 180, 140, "tan"),
XColorName(210, 105,  30, "chocolate"),
XColorName(178,  34,  34, "firebrick"),
XColorName(165,  42,  42, "brown"),
XColorName(233, 150, 122, "DarkSalmon"),
XColorName(250, 128, 114, "salmon"),
XColorName(255, 160, 122, "LightSalmon"),
XColorName(255, 165,   0, "orange"),
XColorName(255, 140,   0, "DarkOrange"),
XColorName(255, 127,  80, "coral"),
XColorName(240, 128, 128, "LightCoral"),
XColorName(255,  99,  71, "tomato"),
XColorName(255,  69,   0, "OrangeRed"),
XColorName(255,   0,   0, "red"),
XColorName(255, 105, 180, "HotPink"),
XColorName(255,  20, 147, "DeepPink"),
XColorName(255, 192, 203, "pink"),
XColorName(255, 182, 193, "LightPink"),
XColorName(219, 112, 147, "PaleVioletRed"),
XColorName(176,  48,  96, "maroon"),
XColorName(199,  21, 133, "MediumVioletRed"),
XColorName(208,  32, 144, "VioletRed"),
XColorName(255,   0, 255, "magenta"),
XColorName(238, 130, 238, "violet"),
XColorName(221, 160, 221, "plum"),
XColorName(218, 112, 214, "orchid"),
XColorName(186,  85, 211, "MediumOrchid"),
XColorName(153,  50, 204, "DarkOrchid"),
XColorName(148,   0, 211, "DarkViolet"),
XColorName(138,  43, 226, "BlueViolet"),
XColorName(160,  32, 240, "purple"),
XColorName(147, 112, 219, "MediumPurple"),
XColorName(216, 191, 216, "thistle"),
XColorName(255, 250, 250, "snow1"),
XColorName(238, 233, 233, "snow2"),
XColorName(205, 201, 201, "snow3"),
XColorName(139, 137, 137, "snow4"),
XColorName(255, 245, 238, "seashell1"),
XColorName(238, 229, 222, "seashell2"),
XColorName(205, 197, 191, "seashell3"),
XColorName(139, 134, 130, "seashell4"),
XColorName(255, 239, 219, "AntiqueWhite1"),
XColorName(238, 223, 204, "AntiqueWhite2"),
XColorName(205, 192, 176, "AntiqueWhite3"),
XColorName(139, 131, 120, "AntiqueWhite4"),
XColorName(255, 228, 196, "bisque1"),
XColorName(238, 213, 183, "bisque2"),
XColorName(205, 183, 158, "bisque3"),
XColorName(139, 125, 107, "bisque4"),
XColorName(255, 218, 185, "PeachPuff1"),
XColorName(238, 203, 173, "PeachPuff2"),
XColorName(205, 175, 149, "PeachPuff3"),
XColorName(139, 119, 101, "PeachPuff4"),
XColorName(255, 222, 173, "NavajoWhite1"),
XColorName(238, 207, 161, "NavajoWhite2"),
XColorName(205, 179, 139, "NavajoWhite3"),
XColorName(139, 121,  94, "NavajoWhite4"),
XColorName(255, 250, 205, "LemonChiffon1"),
XColorName(238, 233, 191, "LemonChiffon2"),
XColorName(205, 201, 165, "LemonChiffon3"),
XColorName(139, 137, 112, "LemonChiffon4"),
XColorName(255, 248, 220, "cornsilk1"),
XColorName(238, 232, 205, "cornsilk2"),
XColorName(205, 200, 177, "cornsilk3"),
XColorName(139, 136, 120, "cornsilk4"),
XColorName(255, 255, 240, "ivory1"),
XColorName(238, 238, 224, "ivory2"),
XColorName(205, 205, 193, "ivory3"),
XColorName(139, 139, 131, "ivory4"),
XColorName(240, 255, 240, "honeydew1"),
XColorName(224, 238, 224, "honeydew2"),
XColorName(193, 205, 193, "honeydew3"),
XColorName(131, 139, 131, "honeydew4"),
XColorName(255, 240, 245, "LavenderBlush1"),
XColorName(238, 224, 229, "LavenderBlush2"),
XColorName(205, 193, 197, "LavenderBlush3"),
XColorName(139, 131, 134, "LavenderBlush4"),
XColorName(255, 228, 225, "MistyRose1"),
XColorName(238, 213, 210, "MistyRose2"),
XColorName(205, 183, 181, "MistyRose3"),
XColorName(139, 125, 123, "MistyRose4"),
XColorName(240, 255, 255, "azure1"),
XColorName(224, 238, 238, "azure2"),
XColorName(193, 205, 205, "azure3"),
XColorName(131, 139, 139, "azure4"),
XColorName(131, 111, 255, "SlateBlue1"),
XColorName(122, 103, 238, "SlateBlue2"),
XColorName(105,  89, 205, "SlateBlue3"),
XColorName( 71,  60, 139, "SlateBlue4"),
XColorName( 72, 118, 255, "RoyalBlue1"),
XColorName( 67, 110, 238, "RoyalBlue2"),
XColorName( 58,  95, 205, "RoyalBlue3"),
XColorName( 39,  64, 139, "RoyalBlue4"),
XColorName(  0,   0, 255, "blue1"),
XColorName(  0,   0, 238, "blue2"),
XColorName(  0,   0, 205, "blue3"),
XColorName(  0,   0, 139, "blue4"),
XColorName( 30, 144, 255, "DodgerBlue1"),
XColorName( 28, 134, 238, "DodgerBlue2"),
XColorName( 24, 116, 205, "DodgerBlue3"),
XColorName( 16,  78, 139, "DodgerBlue4"),
XColorName( 99, 184, 255, "SteelBlue1"),
XColorName( 92, 172, 238, "SteelBlue2"),
XColorName( 79, 148, 205, "SteelBlue3"),
XColorName( 54, 100, 139, "SteelBlue4"),
XColorName(  0, 191, 255, "DeepSkyBlue1"),
XColorName(  0, 178, 238, "DeepSkyBlue2"),
XColorName(  0, 154, 205, "DeepSkyBlue3"),
XColorName(  0, 104, 139, "DeepSkyBlue4"),
XColorName(135, 206, 255, "SkyBlue1"),
XColorName(126, 192, 238, "SkyBlue2"),
XColorName(108, 166, 205, "SkyBlue3"),
XColorName( 74, 112, 139, "SkyBlue4"),
XColorName(176, 226, 255, "LightSkyBlue1"),
XColorName(164, 211, 238, "LightSkyBlue2"),
XColorName(141, 182, 205, "LightSkyBlue3"),
XColorName( 96, 123, 139, "LightSkyBlue4"),
XColorName(198, 226, 255, "SlateGray1"),
XColorName(185, 211, 238, "SlateGray2"),
XColorName(159, 182, 205, "SlateGray3"),
XColorName(108, 123, 139, "SlateGray4"),
XColorName(202, 225, 255, "LightSteelBlue1"),
XColorName(188, 210, 238, "LightSteelBlue2"),
XColorName(162, 181, 205, "LightSteelBlue3"),
XColorName(110, 123, 139, "LightSteelBlue4"),
XColorName(191, 239, 255, "LightBlue1"),
XColorName(178, 223, 238, "LightBlue2"),
XColorName(154, 192, 205, "LightBlue3"),
XColorName(104, 131, 139, "LightBlue4"),
XColorName(224, 255, 255, "LightCyan1"),
XColorName(209, 238, 238, "LightCyan2"),
XColorName(180, 205, 205, "LightCyan3"),
XColorName(122, 139, 139, "LightCyan4"),
XColorName(187, 255, 255, "PaleTurquoise1"),
XColorName(174, 238, 238, "PaleTurquoise2"),
XColorName(150, 205, 205, "PaleTurquoise3"),
XColorName(102, 139, 139, "PaleTurquoise4"),
XColorName(152, 245, 255, "CadetBlue1"),
XColorName(142, 229, 238, "CadetBlue2"),
XColorName(122, 197, 205, "CadetBlue3"),
XColorName( 83, 134, 139, "CadetBlue4"),
XColorName(  0, 245, 255, "turquoise1"),
XColorName(  0, 229, 238, "turquoise2"),
XColorName(  0, 197, 205, "turquoise3"),
XColorName(  0, 134, 139, "turquoise4"),
XColorName(  0, 255, 255, "cyan1"),
XColorName(  0, 238, 238, "cyan2"),
XColorName(  0, 205, 205, "cyan3"),
XColorName(  0, 139, 139, "cyan4"),
XColorName(151, 255, 255, "DarkSlateGray1"),
XColorName(141, 238, 238, "DarkSlateGray2"),
XColorName(121, 205, 205, "DarkSlateGray3"),
XColorName( 82, 139, 139, "DarkSlateGray4"),
XColorName(127, 255, 212, "aquamarine1"),
XColorName(118, 238, 198, "aquamarine2"),
XColorName(102, 205, 170, "aquamarine3"),
XColorName( 69, 139, 116, "aquamarine4"),
XColorName(193, 255, 193, "DarkSeaGreen1"),
XColorName(180, 238, 180, "DarkSeaGreen2"),
XColorName(155, 205, 155, "DarkSeaGreen3"),
XColorName(105, 139, 105, "DarkSeaGreen4"),
XColorName( 84, 255, 159, "SeaGreen1"),
XColorName( 78, 238, 148, "SeaGreen2"),
XColorName( 67, 205, 128, "SeaGreen3"),
XColorName( 46, 139,  87, "SeaGreen4"),
XColorName(154, 255, 154, "PaleGreen1"),
XColorName(144, 238, 144, "PaleGreen2"),
XColorName(124, 205, 124, "PaleGreen3"),
XColorName( 84, 139,  84, "PaleGreen4"),
XColorName(  0, 255, 127, "SpringGreen1"),
XColorName(  0, 238, 118, "SpringGreen2"),
XColorName(  0, 205, 102, "SpringGreen3"),
XColorName(  0, 139,  69, "SpringGreen4"),
XColorName(  0, 255,   0, "green1"),
XColorName(  0, 238,   0, "green2"),
XColorName(  0, 205,   0, "green3"),
XColorName(  0, 139,   0, "green4"),
XColorName(127, 255,   0, "chartreuse1"),
XColorName(118, 238,   0, "chartreuse2"),
XColorName(102, 205,   0, "chartreuse3"),
XColorName( 69, 139,   0, "chartreuse4"),
XColorName(192, 255,  62, "OliveDrab1"),
XColorName(179, 238,  58, "OliveDrab2"),
XColorName(154, 205,  50, "OliveDrab3"),
XColorName(105, 139,  34, "OliveDrab4"),
XColorName(202, 255, 112, "DarkOliveGreen1"),
XColorName(188, 238, 104, "DarkOliveGreen2"),
XColorName(162, 205,  90, "DarkOliveGreen3"),
XColorName(110, 139,  61, "DarkOliveGreen4"),
XColorName(255, 246, 143, "khaki1"),
XColorName(238, 230, 133, "khaki2"),
XColorName(205, 198, 115, "khaki3"),
XColorName(139, 134,  78, "khaki4"),
XColorName(255, 236, 139, "LightGoldenrod1"),
XColorName(238, 220, 130, "LightGoldenrod2"),
XColorName(205, 190, 112, "LightGoldenrod3"),
XColorName(139, 129,  76, "LightGoldenrod4"),
XColorName(255, 255, 224, "LightYellow1"),
XColorName(238, 238, 209, "LightYellow2"),
XColorName(205, 205, 180, "LightYellow3"),
XColorName(139, 139, 122, "LightYellow4"),
XColorName(255, 255,   0, "yellow1"),
XColorName(238, 238,   0, "yellow2"),
XColorName(205, 205,   0, "yellow3"),
XColorName(139, 139,   0, "yellow4"),
XColorName(255, 215,   0, "gold1"),
XColorName(238, 201,   0, "gold2"),
XColorName(205, 173,   0, "gold3"),
XColorName(139, 117,   0, "gold4"),
XColorName(255, 193,  37, "goldenrod1"),
XColorName(238, 180,  34, "goldenrod2"),
XColorName(205, 155,  29, "goldenrod3"),
XColorName(139, 105,  20, "goldenrod4"),
XColorName(255, 185,  15, "DarkGoldenrod1"),
XColorName(238, 173,  14, "DarkGoldenrod2"),
XColorName(205, 149,  12, "DarkGoldenrod3"),
XColorName(139, 101,   8, "DarkGoldenrod4"),
XColorName(255, 193, 193, "RosyBrown1"),
XColorName(238, 180, 180, "RosyBrown2"),
XColorName(205, 155, 155, "RosyBrown3"),
XColorName(139, 105, 105, "RosyBrown4"),
XColorName(255, 106, 106, "IndianRed1"),
XColorName(238,  99,  99, "IndianRed2"),
XColorName(205,  85,  85, "IndianRed3"),
XColorName(139,  58,  58, "IndianRed4"),
XColorName(255, 130,  71, "sienna1"),
XColorName(238, 121,  66, "sienna2"),
XColorName(205, 104,  57, "sienna3"),
XColorName(139,  71,  38, "sienna4"),
XColorName(255, 211, 155, "burlywood1"),
XColorName(238, 197, 145, "burlywood2"),
XColorName(205, 170, 125, "burlywood3"),
XColorName(139, 115,  85, "burlywood4"),
XColorName(255, 231, 186, "wheat1"),
XColorName(238, 216, 174, "wheat2"),
XColorName(205, 186, 150, "wheat3"),
XColorName(139, 126, 102, "wheat4"),
XColorName(255, 165,  79, "tan1"),
XColorName(238, 154,  73, "tan2"),
XColorName(205, 133,  63, "tan3"),
XColorName(139,  90,  43, "tan4"),
XColorName(255, 127,  36, "chocolate1"),
XColorName(238, 118,  33, "chocolate2"),
XColorName(205, 102,  29, "chocolate3"),
XColorName(139,  69,  19, "chocolate4"),
XColorName(255,  48,  48, "firebrick1"),
XColorName(238,  44,  44, "firebrick2"),
XColorName(205,  38,  38, "firebrick3"),
XColorName(139,  26,  26, "firebrick4"),
XColorName(255,  64,  64, "brown1"),
XColorName(238,  59,  59, "brown2"),
XColorName(205,  51,  51, "brown3"),
XColorName(139,  35,  35, "brown4"),
XColorName(255, 140, 105, "salmon1"),
XColorName(238, 130,  98, "salmon2"),
XColorName(205, 112,  84, "salmon3"),
XColorName(139,  76,  57, "salmon4"),
XColorName(255, 160, 122, "LightSalmon1"),
XColorName(238, 149, 114, "LightSalmon2"),
XColorName(205, 129,  98, "LightSalmon3"),
XColorName(139,  87,  66, "LightSalmon4"),
XColorName(255, 165,   0, "orange1"),
XColorName(238, 154,   0, "orange2"),
XColorName(205, 133,   0, "orange3"),
XColorName(139,  90,   0, "orange4"),
XColorName(255, 127,   0, "DarkOrange1"),
XColorName(238, 118,   0, "DarkOrange2"),
XColorName(205, 102,   0, "DarkOrange3"),
XColorName(139,  69,   0, "DarkOrange4"),
XColorName(255, 114,  86, "coral1"),
XColorName(238, 106,  80, "coral2"),
XColorName(205,  91,  69, "coral3"),
XColorName(139,  62,  47, "coral4"),
XColorName(255,  99,  71, "tomato1"),
XColorName(238,  92,  66, "tomato2"),
XColorName(205,  79,  57, "tomato3"),
XColorName(139,  54,  38, "tomato4"),
XColorName(255,  69,   0, "OrangeRed1"),
XColorName(238,  64,   0, "OrangeRed2"),
XColorName(205,  55,   0, "OrangeRed3"),
XColorName(139,  37,   0, "OrangeRed4"),
XColorName(255,   0,   0, "red1"),
XColorName(238,   0,   0, "red2"),
XColorName(205,   0,   0, "red3"),
XColorName(139,   0,   0, "red4"),
XColorName(255,  20, 147, "DeepPink1"),
XColorName(238,  18, 137, "DeepPink2"),
XColorName(205,  16, 118, "DeepPink3"),
XColorName(139,  10,  80, "DeepPink4"),
XColorName(255, 110, 180, "HotPink1"),
XColorName(238, 106, 167, "HotPink2"),
XColorName(205,  96, 144, "HotPink3"),
XColorName(139,  58,  98, "HotPink4"),
XColorName(255, 181, 197, "pink1"),
XColorName(238, 169, 184, "pink2"),
XColorName(205, 145, 158, "pink3"),
XColorName(139,  99, 108, "pink4"),
XColorName(255, 174, 185, "LightPink1"),
XColorName(238, 162, 173, "LightPink2"),
XColorName(205, 140, 149, "LightPink3"),
XColorName(139,  95, 101, "LightPink4"),
XColorName(255, 130, 171, "PaleVioletRed1"),
XColorName(238, 121, 159, "PaleVioletRed2"),
XColorName(205, 104, 137, "PaleVioletRed3"),
XColorName(139,  71,  93, "PaleVioletRed4"),
XColorName(255,  52, 179, "maroon1"),
XColorName(238,  48, 167, "maroon2"),
XColorName(205,  41, 144, "maroon3"),
XColorName(139,  28,  98, "maroon4"),
XColorName(255,  62, 150, "VioletRed1"),
XColorName(238,  58, 140, "VioletRed2"),
XColorName(205,  50, 120, "VioletRed3"),
XColorName(139,  34,  82, "VioletRed4"),
XColorName(255,   0, 255, "magenta1"),
XColorName(238,   0, 238, "magenta2"),
XColorName(205,   0, 205, "magenta3"),
XColorName(139,   0, 139, "magenta4"),
XColorName(255, 131, 250, "orchid1"),
XColorName(238, 122, 233, "orchid2"),
XColorName(205, 105, 201, "orchid3"),
XColorName(139,  71, 137, "orchid4"),
XColorName(255, 187, 255, "plum1"),
XColorName(238, 174, 238, "plum2"),
XColorName(205, 150, 205, "plum3"),
XColorName(139, 102, 139, "plum4"),
XColorName(224, 102, 255, "MediumOrchid1"),
XColorName(209,  95, 238, "MediumOrchid2"),
XColorName(180,  82, 205, "MediumOrchid3"),
XColorName(122,  55, 139, "MediumOrchid4"),
XColorName(191,  62, 255, "DarkOrchid1"),
XColorName(178,  58, 238, "DarkOrchid2"),
XColorName(154,  50, 205, "DarkOrchid3"),
XColorName(104,  34, 139, "DarkOrchid4"),
XColorName(155,  48, 255, "purple1"),
XColorName(145,  44, 238, "purple2"),
XColorName(125,  38, 205, "purple3"),
XColorName( 85,  26, 139, "purple4"),
XColorName(171, 130, 255, "MediumPurple1"),
XColorName(159, 121, 238, "MediumPurple2"),
XColorName(137, 104, 205, "MediumPurple3"),
XColorName( 93,  71, 139, "MediumPurple4"),
XColorName(255, 225, 255, "thistle1"),
XColorName(238, 210, 238, "thistle2"),
XColorName(205, 181, 205, "thistle3"),
XColorName(139, 123, 139, "thistle4"),
XColorName(  0,   0,   0, "gray0"),
XColorName(  0,   0,   0, "grey0"),
XColorName(  3,   3,   3, "gray1"),
XColorName(  3,   3,   3, "grey1"),
XColorName(  5,   5,   5, "gray2"),
XColorName(  5,   5,   5, "grey2"),
XColorName(  8,   8,   8, "gray3"),
XColorName(  8,   8,   8, "grey3"),
XColorName( 10,  10,  10, "gray4"),
XColorName( 10,  10,  10, "grey4"),
XColorName( 13,  13,  13, "gray5"),
XColorName( 13,  13,  13, "grey5"),
XColorName( 15,  15,  15, "gray6"),
XColorName( 15,  15,  15, "grey6"),
XColorName( 18,  18,  18, "gray7"),
XColorName( 18,  18,  18, "grey7"),
XColorName( 20,  20,  20, "gray8"),
XColorName( 20,  20,  20, "grey8"),
XColorName( 23,  23,  23, "gray9"),
XColorName( 23,  23,  23, "grey9"),
XColorName( 26,  26,  26, "gray10"),
XColorName( 26,  26,  26, "grey10"),
XColorName( 28,  28,  28, "gray11"),
XColorName( 28,  28,  28, "grey11"),
XColorName( 31,  31,  31, "gray12"),
XColorName( 31,  31,  31, "grey12"),
XColorName( 33,  33,  33, "gray13"),
XColorName( 33,  33,  33, "grey13"),
XColorName( 36,  36,  36, "gray14"),
XColorName( 36,  36,  36, "grey14"),
XColorName( 38,  38,  38, "gray15"),
XColorName( 38,  38,  38, "grey15"),
XColorName( 41,  41,  41, "gray16"),
XColorName( 41,  41,  41, "grey16"),
XColorName( 43,  43,  43, "gray17"),
XColorName( 43,  43,  43, "grey17"),
XColorName( 46,  46,  46, "gray18"),
XColorName( 46,  46,  46, "grey18"),
XColorName( 48,  48,  48, "gray19"),
XColorName( 48,  48,  48, "grey19"),
XColorName( 51,  51,  51, "gray20"),
XColorName( 51,  51,  51, "grey20"),
XColorName( 54,  54,  54, "gray21"),
XColorName( 54,  54,  54, "grey21"),
XColorName( 56,  56,  56, "gray22"),
XColorName( 56,  56,  56, "grey22"),
XColorName( 59,  59,  59, "gray23"),
XColorName( 59,  59,  59, "grey23"),
XColorName( 61,  61,  61, "gray24"),
XColorName( 61,  61,  61, "grey24"),
XColorName( 64,  64,  64, "gray25"),
XColorName( 64,  64,  64, "grey25"),
XColorName( 66,  66,  66, "gray26"),
XColorName( 66,  66,  66, "grey26"),
XColorName( 69,  69,  69, "gray27"),
XColorName( 69,  69,  69, "grey27"),
XColorName( 71,  71,  71, "gray28"),
XColorName( 71,  71,  71, "grey28"),
XColorName( 74,  74,  74, "gray29"),
XColorName( 74,  74,  74, "grey29"),
XColorName( 77,  77,  77, "gray30"),
XColorName( 77,  77,  77, "grey30"),
XColorName( 79,  79,  79, "gray31"),
XColorName( 79,  79,  79, "grey31"),
XColorName( 82,  82,  82, "gray32"),
XColorName( 82,  82,  82, "grey32"),
XColorName( 84,  84,  84, "gray33"),
XColorName( 84,  84,  84, "grey33"),
XColorName( 87,  87,  87, "gray34"),
XColorName( 87,  87,  87, "grey34"),
XColorName( 89,  89,  89, "gray35"),
XColorName( 89,  89,  89, "grey35"),
XColorName( 92,  92,  92, "gray36"),
XColorName( 92,  92,  92, "grey36"),
XColorName( 94,  94,  94, "gray37"),
XColorName( 94,  94,  94, "grey37"),
XColorName( 97,  97,  97, "gray38"),
XColorName( 97,  97,  97, "grey38"),
XColorName( 99,  99,  99, "gray39"),
XColorName( 99,  99,  99, "grey39"),
XColorName(102, 102, 102, "gray40"),
XColorName(102, 102, 102, "grey40"),
XColorName(105, 105, 105, "gray41"),
XColorName(105, 105, 105, "grey41"),
XColorName(107, 107, 107, "gray42"),
XColorName(107, 107, 107, "grey42"),
XColorName(110, 110, 110, "gray43"),
XColorName(110, 110, 110, "grey43"),
XColorName(112, 112, 112, "gray44"),
XColorName(112, 112, 112, "grey44"),
XColorName(115, 115, 115, "gray45"),
XColorName(115, 115, 115, "grey45"),
XColorName(117, 117, 117, "gray46"),
XColorName(117, 117, 117, "grey46"),
XColorName(120, 120, 120, "gray47"),
XColorName(120, 120, 120, "grey47"),
XColorName(122, 122, 122, "gray48"),
XColorName(122, 122, 122, "grey48"),
XColorName(125, 125, 125, "gray49"),
XColorName(125, 125, 125, "grey49"),
XColorName(127, 127, 127, "gray50"),
XColorName(127, 127, 127, "grey50"),
XColorName(130, 130, 130, "gray51"),
XColorName(130, 130, 130, "grey51"),
XColorName(133, 133, 133, "gray52"),
XColorName(133, 133, 133, "grey52"),
XColorName(135, 135, 135, "gray53"),
XColorName(135, 135, 135, "grey53"),
XColorName(138, 138, 138, "gray54"),
XColorName(138, 138, 138, "grey54"),
XColorName(140, 140, 140, "gray55"),
XColorName(140, 140, 140, "grey55"),
XColorName(143, 143, 143, "gray56"),
XColorName(143, 143, 143, "grey56"),
XColorName(145, 145, 145, "gray57"),
XColorName(145, 145, 145, "grey57"),
XColorName(148, 148, 148, "gray58"),
XColorName(148, 148, 148, "grey58"),
XColorName(150, 150, 150, "gray59"),
XColorName(150, 150, 150, "grey59"),
XColorName(153, 153, 153, "gray60"),
XColorName(153, 153, 153, "grey60"),
XColorName(156, 156, 156, "gray61"),
XColorName(156, 156, 156, "grey61"),
XColorName(158, 158, 158, "gray62"),
XColorName(158, 158, 158, "grey62"),
XColorName(161, 161, 161, "gray63"),
XColorName(161, 161, 161, "grey63"),
XColorName(163, 163, 163, "gray64"),
XColorName(163, 163, 163, "grey64"),
XColorName(166, 166, 166, "gray65"),
XColorName(166, 166, 166, "grey65"),
XColorName(168, 168, 168, "gray66"),
XColorName(168, 168, 168, "grey66"),
XColorName(171, 171, 171, "gray67"),
XColorName(171, 171, 171, "grey67"),
XColorName(173, 173, 173, "gray68"),
XColorName(173, 173, 173, "grey68"),
XColorName(176, 176, 176, "gray69"),
XColorName(176, 176, 176, "grey69"),
XColorName(179, 179, 179, "gray70"),
XColorName(179, 179, 179, "grey70"),
XColorName(181, 181, 181, "gray71"),
XColorName(181, 181, 181, "grey71"),
XColorName(184, 184, 184, "gray72"),
XColorName(184, 184, 184, "grey72"),
XColorName(186, 186, 186, "gray73"),
XColorName(186, 186, 186, "grey73"),
XColorName(189, 189, 189, "gray74"),
XColorName(189, 189, 189, "grey74"),
XColorName(191, 191, 191, "gray75"),
XColorName(191, 191, 191, "grey75"),
XColorName(194, 194, 194, "gray76"),
XColorName(194, 194, 194, "grey76"),
XColorName(196, 196, 196, "gray77"),
XColorName(196, 196, 196, "grey77"),
XColorName(199, 199, 199, "gray78"),
XColorName(199, 199, 199, "grey78"),
XColorName(201, 201, 201, "gray79"),
XColorName(201, 201, 201, "grey79"),
XColorName(204, 204, 204, "gray80"),
XColorName(204, 204, 204, "grey80"),
XColorName(207, 207, 207, "gray81"),
XColorName(207, 207, 207, "grey81"),
XColorName(209, 209, 209, "gray82"),
XColorName(209, 209, 209, "grey82"),
XColorName(212, 212, 212, "gray83"),
XColorName(212, 212, 212, "grey83"),
XColorName(214, 214, 214, "gray84"),
XColorName(214, 214, 214, "grey84"),
XColorName(217, 217, 217, "gray85"),
XColorName(217, 217, 217, "grey85"),
XColorName(219, 219, 219, "gray86"),
XColorName(219, 219, 219, "grey86"),
XColorName(222, 222, 222, "gray87"),
XColorName(222, 222, 222, "grey87"),
XColorName(224, 224, 224, "gray88"),
XColorName(224, 224, 224, "grey88"),
XColorName(227, 227, 227, "gray89"),
XColorName(227, 227, 227, "grey89"),
XColorName(229, 229, 229, "gray90"),
XColorName(229, 229, 229, "grey90"),
XColorName(232, 232, 232, "gray91"),
XColorName(232, 232, 232, "grey91"),
XColorName(235, 235, 235, "gray92"),
XColorName(235, 235, 235, "grey92"),
XColorName(237, 237, 237, "gray93"),
XColorName(237, 237, 237, "grey93"),
XColorName(240, 240, 240, "gray94"),
XColorName(240, 240, 240, "grey94"),
XColorName(242, 242, 242, "gray95"),
XColorName(242, 242, 242, "grey95"),
XColorName(245, 245, 245, "gray96"),
XColorName(245, 245, 245, "grey96"),
XColorName(247, 247, 247, "gray97"),
XColorName(247, 247, 247, "grey97"),
XColorName(250, 250, 250, "gray98"),
XColorName(250, 250, 250, "grey98"),
XColorName(252, 252, 252, "gray99"),
XColorName(252, 252, 252, "grey99"),
XColorName(255, 255, 255, "gray100"),
XColorName(255, 255, 255, "grey100"),
XColorName(169, 169, 169, "DarkGrey"),
XColorName(169, 169, 169, "DarkGray"),
XColorName(0  ,   0, 139, "DarkBlue"),
XColorName(0  , 139, 139, "DarkCyan"),
XColorName(139,   0, 139, "DarkMagenta"),
XColorName(139,   0,   0, "DarkRed"),
XColorName(144, 238, 144, "LightGreen"),

//! some more colors from ketmar
XColorName( 80,  80,  96, "Indigo"),
XColorName(143,   0,   0, "DeepRed"),
XColorName(255, 175,  63, "BrightBrown"),
XColorName(207, 223, 144, "BleachedBone"),
];


public immutable(XColorName)* xFindColorByName (const(char)[] name) pure nothrow @trusted @nogc {
  // s1 can contain '_', '-' and spaces
  static bool xstrcmp (const(char)[] s0, const(char)[] s1) pure nothrow @trusted @nogc {
    while (s0.length && s1.length) {
      if (s1.ptr[0] <= ' ' || s1.ptr[0] == '_' || s1.ptr[0] == '-') { s1 = s1[1..$]; continue; }
      char c0 = s0.ptr[0];
      // try the easiest case first
      if (c0 != s1.ptr[0]) {
        c0 |= 0x20; // convert to ascii lowercase
        if (c0 < 'a' || c0 > 'z') return false; // it wasn't a letter, no need to check the second char
        // c0 is guaranteed to be a lowercase ascii here
        if (c0 != (s1.ptr[0]|0x20)) return false; // c1 will become a lowercase ascii only if it was uppercase/lowercase ascii
      }
      s0 = s0[1..$];
      s1 = s1[1..$];
    }
    while (s1.length && (s1.ptr[0] <= ' ' || s1.ptr[0] == '_' || s1.ptr[0] == '-')) s1 = s1[1..$];
    return (s0.length == 0 && s1.length == 0);
  }

  while (name.length && (name.ptr[0] <= ' ' || name.ptr[0] == '_' || name.ptr[0] == '-')) name = name[1..$];
  while (name.length && (name[$-1] <= ' ' || name[$-1] == '_' || name[$-1] == '-')) name = name[0..$-1];
  if (name.length < 3) return null; // minimum name length
  foreach (const ref np; xColorNameList[]) {
    if (xstrcmp(np.name, name)) return &np;
  }
  return null;
}
